IPSW-IMG4-CREATE(1)

NAME
ipsw-img4-create - Create an IMG4 file

SYNOPSIS
ipsw img4 create [flags]

DESCRIPTION
Create an IMG4 file

OPTIONS
-g, --boot-nonce=""
    Boot nonce to set in Img4 restore info

-c, --compress="none"
    IM4P compression to use (none, lzss, lzfse, lzfse_iboot)

-e, --extra=""
    Extra IM4P payload data to set

-h, --help[=false]
    help for create

-m, --im4m=""
    Input Img4 manifest file

-p, --im4p=""
    Input Img4 payload file

-r, --im4r=""
    Input Img4 restore info file

-i, --input=""
    Input file for IM4P payload data (raw data, not IM4P file)

-o, --output=""
    Output file

-t, --type=""
    IM4P type to set

-v, --version=""
    IM4P version to set

OPTIONS INHERITED FROM PARENT COMMANDS
--color[=false]
    colorize output

--config=""
    config file (default is $HOME/.config/ipsw/config.yaml)

--no-color[=false]
    disable colorize output

-V, --verbose[=false]
    verbose output

EXAMPLE
    # Create IMG4 from existing IM4P with manifest and restore info
    ❯ ipsw img4 create --im4p payload.im4p --im4m manifest.im4m --im4r restore.im4r --output kernel.img4
    # Create IMG4 from raw kernel with LZSS compression and manifest
    ❯ ipsw img4 create --input kernelcache --type krnl --description "Kernelcache" --compress lzss --im4m manifest.im4m --output kernel.img4
    # Create IMG4 with boot nonce (generates IM4R automatically)
    ❯ ipsw img4 create --input sep-firmware.bin --type sepi --boot-nonce 1234567890abcdef --im4m manifest.im4m --output sep.img4
    # Create IMG4 with extra data (extra data requires --compress lzss)
    ❯ ipsw img4 create --input payload.bin --type logo --compress lzss --extra extra.bin --im4m manifest.im4m --output logo.img4
    # Create unsigned IMG4 (no manifest) - for testing only
    ❯ ipsw img4 create --input test.bin --type test --description "Test payload" --output test.img4
    # Create IMG4 from iBoot with specific compression
    ❯ ipsw img4 create --input iboot.raw --type ibot --description "iBoot" --compress lzfse --im4m iboot.im4m --output iboot.img4
    # Create IMG4 from raw data with common FourCC codes
    ❯ ipsw img4 create --input kernelcache.bin --type krnl --compress lzss --im4m manifest.im4m --output kernel.img4
    ❯ ipsw img4 create --input devicetree.bin --type dtre --compress lzss --im4m manifest.im4m --output devicetree.img4
    ❯ ipsw img4 create --input ramdisk.dmg --type rdsk --compress lzss --im4m manifest.im4m --output ramdisk.img4
    # Re-type existing IM4P file with new type
    ❯ ipsw img4 create --im4p existing.im4p --type newt --im4m manifest.im4m --output retyped.img4

SEE ALSO
ipsw-img4(1)

HISTORY
11-Feb-2026 Auto generated by spf13/cobra